// -------------------------------------------------------------------------\\
//          
// File:        constuff.h
// Author:      Bettina McCormick
//          
// Project:     Atlantis: COP 2224 VCC; Summer 1999
//          
// Created:     June 01, 1999
// Updated:     July 31, 1999
// Date due:    August 04, 1999
//             
// Description: Specification of Constuff class
//
//              Static class - methods can be accessed without an instance 
//              of the class.
//              This class contains many handy methods for use in console 
//              applications  
//
// -------------------------------------------------------------------------//

#ifndef CONSTUFF_H // standard header wrapper
#define CONSTUFF_H

#include <iostream>
#include <string>
#include <ctime>

namespace Atlantis // project namespace
{
  
  class Constuff
  {   
  public:
    static std::string Int2String( int i );
    /**------------------------------------------------------------------------
    // converts int to ascii
    //-----------------------------------------------------------------------*/
    
    static std::string Double2String( double d );
    /**------------------------------------------------------------------------
    // converts float to ascii
    //-----------------------------------------------------------------------*/
    
    static void UserEntry( std::string label, std::string & entry, int length);
    /**------------------------------------------------------------------------
    // overloaded method: takes a string, ref to int and 2 ints
    // outputs label to screen with range to choose from
    // prompts user for entry between range of min and max, inclusive
    // memory in entry is changed to user entry from keyboard
    // required that min not less than 0
    //-----------------------------------------------------------------------*/
    
    static void UserEntry( std::string label, int & entry, int min, int max );
    /**------------------------------------------------------------------------
    // overloaded method: takes a string, ref to string and an int
    // prompts user for a string
    // memory in entry is changed to user entry from keyboard
    // length is limit of string length read from keyboard
    //-----------------------------------------------------------------------*/
    
    static void UserEntry ( std::string label, std::string & entry );
    /**------------------------------------------------------------------------
    // overloaded method: takes a string, ref to string
    // prompts user for a string
    // memory in entry is changed to user entry from keyboard
    // uses default length for string of 40
    //-----------------------------------------------------------------------*/
    
    static void PauseScreen( void );
    /**------------------------------------------------------------------------
    // pauses the screen prompting user to press any key to continue
    //-----------------------------------------------------------------------*/
    
    static void ReturnError( void );
    /**------------------------------------------------------------------------
    // fixes return keyy error
    //-----------------------------------------------------------------------*/

    static void ClearScreen( void );
    /**------------------------------------------------------------------------
    // clears the screen visible to the user on the console
    //-----------------------------------------------------------------------*/
    
    static void Welcome( void );
    /**------------------------------------------------------------------------
    // displays a description of the program to the user 
    // change std::cout lines for each purpose
    //-----------------------------------------------------------------------*/
    
    static bool GetChoice( void );
    /**------------------------------------------------------------------------
    // queries the user for a choice of yes (true) or no (false)
    // returns their choice
    //-----------------------------------------------------------------------*/

    static int GetRandNum( int max_rand );
    /**------------------------------------------------------------------------
    // returns a random number between 1 and the max_rand inclusive
    //-----------------------------------------------------------------------*/

  private:
    enum LIMITS { MAXBUFF = 1024 }; // maximum size of console line in bytes
  };
  
} // namespace Atlantis

#endif // CONSTUFF_H

// eof constuff.h
