// -------------------------------------------------------------------------\\
//          
// File:        crystal.h
// Author:      Bettina McCormick
//          
// Project:     Atlantis: COP 2224 VCC; Summer 1999
//          
// Created:     July 02, 1999
// Updated:     July 28, 1999
// Date due:    August 04, 1999
//             
// Description: Specification for Crystal class
//      
//              Inherits from Target - Crystal "is a" Target
//        
// Notes:       Turn on symbol CRYSTAL_TEST to test this component
//      
// -------------------------------------------------------------------------//
  
#ifndef CRYSTAL_H         // standard header wrapper
#define CRYSTAL_H
        
#include <iostream>
#include <string>
        
#include "constuff.h"
#include "target.h"
  
namespace Atlantis    // project namespace
{
    
  static enum CrystalTypes   // for better readability
  {
    LAUGHTER,       // 0
    FORGIVENESS,    // 1
    PEACE,          // 2
    JOY,            // 3
    LOVE            // 4
  };
  
  class Crystal : public Target // inherits from target
  {
  public:
    static Crystal * Create ( int crystal_type );
    /**------------------------------------------------------------------------
    // no public constructor: this calls private constructor to create instance
    // of Crystal and returns Crystal *
    //-----------------------------------------------------------------------*/
      
    ~Crystal();
    /**------------------------------------------------------------------------
    // destructor
    //-----------------------------------------------------------------------*/
      
    bool Hit( void );
    /**------------------------------------------------------------------------
    // returns true and hits Crystal if not already destroyed, false otherwise
    //-----------------------------------------------------------------------*/
    
    void Show( void ) const;
    /**------------------------------------------------------------------------
    // calls base class method: shows crystals name, armor level, hits & status
    //-----------------------------------------------------------------------*/
    
    void Show ( bool hitflag ) const;
    /**------------------------------------------------------------------------
    // overloaded show method: hitflag is true if crystal is hit, 
    // false if missed
    //-----------------------------------------------------------------------*/
    
    void Abstract ( void );
    /**------------------------------------------------------------------------
    // fullfills virtual bass class method
    //-----------------------------------------------------------------------*/
    
  private:
    Crystal ( std::string name, int armor, int maxdepth, int val,int t_type );
    /**------------------------------------------------------------------------
    // private constructor calls virtual constructor of base class
    //-----------------------------------------------------------------------*/
    
    int value; // value of crystal - used in scoring
  }; // end class Crystal
  
} // namespace Atlantis

#endif // CRYSTAL_H

// eof crystal.h
