// -------------------------------------------------------------------------\\
//          
// File:        game.h
// Author:      Bettina McCormick
//          
// Project:     Atlantis: COP 2224 VCC; Summer 1999
//          
// Created:     July 31, 1999
// Updated:     August 01, 1999
// Date due:    August 04, 1999
//             
// Description: Specification for Game class
//
//        
// Notes:       Turn on symbol GAME_TEST to test the component

// -------------------------------------------------------------------------//

#ifndef GAME_H
#define GAME_H

#include <iostream>

#include "lostcity.h"
#include "player.h"

namespace Atlantis // project namespace
{
  
  class Game 
  {
  public:
    Game();   // constructor
    ~Game();  // destructor
    void Play( void );    // major method
    bool Get_status ( void );
  private:
    Player * villian;     // villian player
    Player * hero;        // hero player
    Lostcity * lostcity;  // lostcity
    int dif_level;        // difficulty level
    bool status;
    enum LIMITS { MAXPODS=5, MAXPLAYERS=1, MAXTRIES=100, 
                  MAXTIME=10 }; 
  };
  
} // namespace Atlantis
#endif // 

