// -------------------------------------------------------------------------\\
//          
// File:        game.cpp
// Author:      Bettina McCormick
//          
// Project:     Atlantis: COP 2224 VCC; Summer 1999
//          
// Created:     July 31, 1999
// Updated:     August 01, 1999
// Date due:    August 04, 1999
//             
// Description: Implementation for Game class
//
//        
// Notes:       Turn on symbol GAME_TEST to test the component

// -------------------------------------------------------------------------//
    
#include "game.h"
    
namespace Atlantis // project namespace
{
  
  Game::Game()
  /**------------------------------------------------------------------------
  // public constructor: default - no arguments
  //-----------------------------------------------------------------------*/
  {
    status = true;      // set true

    villian = new Player( "Gibrato" );  //create villian
    if ( villian == 0 )    // check pointer
    {
      std::cerr << "Memory Allocation Error!" << std::endl;
      status = false;
    }

    hero = new Player( "Ayram" );  //create hero
    if (hero == 0 )    // check pointer
    {
      std::cerr << "Memory Allocation Error!" << std::endl;
      status = false;
    }
    
     lostcity = new Lostcity( "Atlantis" ); // create city
    if ( lostcity == 0 )    // check pointer
    {
      std::cerr << "Memory Allocation Error!" << std::endl;
      status = false;
    }
  } // end constructor
  
  Game::~Game()
  /**------------------------------------------------------------------------
  // destructor - clean up lost city and players
  //-----------------------------------------------------------------------*/
  {
    if ( lostcity )     // check ponter
    {
      delete lostcity;  // delete 
      lostcity = 0;     // set to null
    }
    if ( villian )       // check pointer  
    {
      delete villian;    // delete
      villian = 0;       // set to null
    }
    if ( hero )       // check pointer  
    {
      delete hero;    // delete
      hero = 0;       // set to null
    }
  } // end destructor
    
      
  void
  Game::Play()
  /**------------------------------------------------------------------------
  // major method - the guts of the game
  //-----------------------------------------------------------------------*/
  {
    bool loop_exit = false;   // assume false
    int more = 0;             // choice for more
    int help = 0;             // choice for hints
    std::string helpstr 
      = "Would you like some help? 1-Show Lostcity 2-Show Targets Info";
    
    hero->AnchorCrystals( lostcity );    // hero hides crystals


    Constuff::Welcome();    // welcome



    dif_level = lostcity->User_defines_level(); // get dif level

    villian->Cast_evils_pods( lostcity, dif_level );
                                      // villian casts pods
    while ( !loop_exit )
    {                    // while still in the game
      if ( hero->Hit( lostcity ) )
      {                   // if hit
        hero->Show();     // show score, etc
      }
      
      if ( lostcity->Get_active_targets() == 0 )
      {
        std::cout << "You Win!" << std::endl; // check active targets
        loop_exit = true;
        continue;
      }
      else if ( hero->Get_number_tries() >+ MAXTRIES )
      {                   // check number of tries
        std::cout << "You have exhausted your number of tries!" 
                  << std::endl;
        loop_exit = false;
        continue;     
      }
      
      std::cout << "Would you like to keep playing?  ";
      if( Constuff::GetChoice() == true )
      {
        more = 1;     // check if still want to play
      }
      else 
      {
        more = 0;
      }
      
      switch ( more )
      {
        case 0:     // no more play
        {
          loop_exit = true;
          continue;         
        }
        break;

        case 1:   // fall through 
        {
        }
        break;

        default:
        {
        }
        break;
      }
    
      Constuff::UserEntry("1-Show Lostcity  2-Show Targets 3-Show Score", 
                          help, 1, 3);
      switch ( help )
      {
        case 1:
        {
          lostcity->Show();   // show lostcity and taget locations
        }
        break;
          
        case 2:     // show pod info
        {
          lostcity->ShowTargets(Atlantis::POD);
        }
        break;
        case 3:     // show player info
        {
          hero->Show();       // show player
        }
        break;

        default:
        {
        }
        break;
      }
    }
    
    hero->Show();       // show player
    Constuff::PauseScreen();
    
  }
  
} // namespace

    
    
#ifdef GAME_TEST
  /**------------------------------------------------------------------------
  // unit test for the methods in this class
  //-----------------------------------------------------------------------*/
  
int
main ( void )
{

// pending investigation
  return (0);
} // end main
    
#endif // GAME_TEST

// eof game.cpp

