// ***************************************************************************
//       
// File:        lmach.h
// Author:      Bettina McCormick
//       
// Project:     Midterm: COP 2224 VCC; Summer 1999
// Template:    Created by Professor Richard Mudge
//       
// Created:     June 15, 1999
// Updated:     June 21, 1999
// Date due:    June 28, 1999
//          
// Description: Specification for the LottoMachine object that is used with  
//              the ball object in a simulation of a lotto machine.
//       
// ***************************************************************************
         
         
#ifndef LMACH_H   // standard header wrapper
#define LMACH_H
         
#include "ball.h"

#include <iostream.h> // don't assume these have been included in other header
#include <iomanip.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
         
   class LottoMachine
   {
   public:
      
      LottoMachine( unsigned char number_balls = 49 );  // Constructor
      
      ~LottoMachine(); // Destructor
      
      const Ball & Pick ( void );  // Picks a ball
      
      unsigned char Get_machine_size ( void ); // Returns value of machine size
      
      int  Get_balls_picked ( void );  // Returns value of balls_picked
      
      void Reset ( int index );  // Resets ball on index in the Lotto Machine
      
      void Reset ( void );  // Resets all the balls in the Lotto Machine

      
   private:
      
      enum size { MAX_BALLS = 49,     // Maximum balls any machine can have
                  ZERO_BASED = 10 };  // Max size of zero-based machine 
      
      unsigned char machine_size;     // Number of balls of this machine
      
      Ball contents[ MAX_BALLS ];     // Array of balls
      
      int  balls_picked;              // Value of balls picked
      
      int indexes_tried[ MAX_BALLS ]; // To prevent wasted cycles   
   };
      
#endif

// end lmach.h
