// **************************************************************************
//          
// File:        quickpick.cpp
// Author:      Bettina McCormick
//          
// Project:     Midterm: COP 2224 VCC; Summer 1999
//          
// Created:     June 21, 1999
// Updated:     June 25, 1999
// Date due:    June 28, 1999
//             
// Description: This is a console application that implements picking 
//              lottery numbers for chosen play slips.  It is based on 
//              the Florida Lottery system and the user will need some 
//              knowlege of the different play slips available.  
//              The object of this main executable is to provide a  
//              lottery player with a program to select their lottery 
//              numbers; the result is much the same as a "quick pick" 
//              choice on a play slip, but more fun!
//
//              This main file was written as an enhancement to the midterm 
//              specifications.  It is written in ansi C++ and uses object 
//              oriented design.  Future revisions of this simulation could 
//              explore inheritance from the LottoMachine Class.  
//
// **************************************************************************
         
   // "main" funtions exist in each class file wrapped in a #ifdef..#endif;
   // this facilitates unit testing; However,this is the main executable file
         
      
   #include "playslip.h"
   #include <stdio.h>
            
            
   //------------------------------------------------------FUNTION PROTOTYPES
            
   void //  displays a description of the program to the user
   myWelcome( void );

        //  queries the user if they want to use the program
   bool //  returns true if they do and false if they don't
   getChoice( void ); 

   int  //  returns the integer corresponding to the slip type chosen by user 
   slipType_chosen( void );

   int  //   returns the number of panels chosen by user 
   panelNo_chosen( void ); 
      
      
   //--------------------------------------------------------------BEGIN MAIN
         
         
   int  // Main program 
   main ( void )
   {
      bool  temp = false;       // temp varaible for display
      char  tempinput[1] = {0}; // temp variable for input from keyboard
      bool  option = false;     // option to use program; assume false
      bool  file_option = false;// option to use file; assume false
      int   given_file_option = 0;// variable to flag ask file only once
      ofstream qckpckDataFile;  // pointer to stream for output
      unsigned char slip_type = 6; // which type of lottery play slip
      unsigned char no_panels = 5; // how many pannels to be filled on slip
      char goodbye;// = {0};          // variable to end program 
      PlaySlip myLuckyCard ( slip_type, no_panels ); // basic card 
         
      //-----------------------------------------------------END DECLARATIONS
         
      myWelcome(); // describe program purpose
         
      cout << "\n\nWould you like to use this program?" << endl;
      option = ( bool ) getChoice(); // get users choice to use program
         
      while ( option ) // while the user choses yes
      {
         if ( given_file_option < 1 )
         {
            cout  << "\n\nWould you like to write the results to a file?" 
                  << endl;
            file_option = ( bool ) getChoice(); // get users choice 
         }         
       
         if ( (file_option == true) &&  (given_file_option < 1) )
         {  // if they chose file and this is the 1st time
            qckpckDataFile.open( "quickpick.dat", ios::out ); 
               
            if ( !qckpckDataFile.is_open() )
            { // if file did not open, note it to the user 
               cout  << "The file could not be opened.\n" 
                     << "Try this option on the next execution." << endl;
            }
         } // end if they chose file and this is the 1st time
         
         cout << "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n";
      
         myLuckyCard.Reset();  // reset card to largest lotto as default
      
         slip_type = slipType_chosen(); // prompt for new slip type
         no_panels = panelNo_chosen();  // prompt for new no of panels
      
         myLuckyCard.Set_values ( slip_type, no_panels ); // make new slip
         myLuckyCard.Fill_slip(); // get number and fill slip

         cout << "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n";
      
         myLuckyCard.Show();
         
         if ( file_option )
         { // if they chose a file
            myLuckyCard.Show( qckpckDataFile );
         }
         given_file_option++; // increment so file won't be oppened again
         
         cout  << "\n\nWould you like run this for another Play Slip?" 
               << endl;
         option = ( bool ) getChoice(); // does user want to play again?
      
      } // end while option to keep using program

      if ( file_option )
      { // if they chose a file
         cout  << "\nYour results have also been written to the file," 
               << " \"quickpick.dat\".\n" 
               << "You can open this file with any text editor." << endl;
      } // end they chose a file
               
      cout << "\n\n\t\t***  MAY THE FORCE BE WITH YOU!!!  ***\n" << endl;
      goodbye = getchar(); // pauses program for user to read cout message
        
      return EXIT_SUCCESS;
            
   } // end main
      
      
   //----------------------------------------------------BEGIN MAIN FUNCTIONS
   void  
   myWelcome( void ) 
   //------------------------------------------------------------------------
   // displays a description of the program to the user 
   //------------------------------------------------------------------------
   {
      cout  << "Welcome!  \n\n\tThis program will pick the lottery numbers"
            << " for a" << endl;    // can change these lines
      cout  << "Florida Lottery Play Slip.  You will have a choice of 4 Play"
            << endl;                // for each program
      cout  << "Slips, and you will also be able to indicate the number of " 
            << endl;                // to proovide description
      cout  << "panels for which you want the lottery numbers to be chosen."
            << endl;                // and welcome
   } // end myWelcome( void ) 


   bool 
   getChoice( void ) 
   //------------------------------------------------------------------------
   // queries the user if they want to use the program
   // returns true if they do and false if they don't 
   //------------------------------------------------------------------------
   {
      bool  choice = false;// boolean to be determined and returned
      char  temp[1] = {0}; // temp variable to hold input from keyboard
      
      cout << "(1 = YES / 2 = NO):  ";
      cin  >> temp;    // grab anything else they might have entered
        
      while ( (temp[0] != '1') && (temp[0] != '2') )
      {  // guarentees the only values entered are 1 or 2   
         cout << "\n\n\tYou must enter either  1 = YES  or  2 = NO:  ";
         cin >> temp;
      }
         
      if (temp[0] == '1')
      {
         choice = true; 
      }
         
      return ( choice );
   
   } // end getChoice( void )  


   int 
   slipType_chosen( void )
   //------------------------------------------------------------------------
   // returns the integer corresponding to the slip type chosen by user 
   //------------------------------------------------------------------------
   {
      int slip_type = 0;      // variable to hold slip type chosen
      char temp[1] = {0};     // temp variable to hold input from keyboard
      
      cout  << "\n\nFor which Play Slip do you want the lottery numbers"
            << " chosen?" << endl;
      cout << "( 3 = Cash3    4 = Play4    5 = Fantasy5    6 = Lotto ):  "; 
      cin >> temp;
      slip_type = atoi ( temp );
         
      while ( ( slip_type < 3 ) || ( slip_type > 6 ) )
      {  // guarentees the only values entered are 3,4,5,6  
         cout << "\n\n\tYou must enter 3, 4, 5 or 6:  ";
         cin >> temp;
         slip_type = atoi ( temp );
      }
   
      return ( slip_type );
   
   } // end getSlipType( void ) 
      
         
   int
   panelNo_chosen( void )
   //------------------------------------------------------------------------
   // returns the number of panels chosen by user 
   //------------------------------------------------------------------------
   {
      int panel_no = 0;    // variable to hold number of panels chosen
      char temp[1] ={0};   // temp variable to hold input from keyboard
         
      cout  << "\n\nFor how many panels do you want the lottery "
            << "numbers chosen?" << endl;
      cout << "( 1 - 5 ):  "; 
      cin >> temp;
      panel_no = atoi( temp );
      
      while ( ( panel_no < 1 ) || ( panel_no > 5 ) )
      {  // guarentees the only values entered are 1,2,3,4,5   
         cout << "\n\n\tYou must enter 1, 2, 3, 4 or 5 :  ";
         cin >> temp;
         panel_no =  atoi( temp );
      }
         
      return ( panel_no );
      
   } // end getPanelNo( void )
      
// end quickpick.cpp
