/* trees.c
/******************************************************************************\
	Bettina McCormick, April 1998, CSIII, Dr. Leeson, Assignment #3

	Tree Investigation Project  - Due Date: Wednesday April 29, 1998

	Main Program:  trees.c  Version 2.1 - last updated  April 27, 1998

	This program investigates two different tree structures:
	the Binary Search Tree (BST) and the Two-Three Tree (TTT).

\******************************************************************************/

/************************   WHAT THIS PROGRAM DOES   **************************\

This program will open a text file of non-negative
integers (one per line) and insert them into a binary search tree.
It will then look up each of the integers and after finding
them all, will output the total number of data compares made to
the output file specified.

It will then rewind the a text file of non-negative
integers (one per line) and insert them into a 2-3 tree.  It
will then look up each of the integers and after finding them
all, will output the total number of data compares made to
the output file specified.

\******************************************************************************/
/***************************   INPUT SPECIFCATIONS   **************************\

The input for this program ia a file or files containing non-negative
integers (one per line).  Enter as many files as you wish on the command line.
However, the last arguement you enter must be the name of the your output file.
The Comparisons Report will be written to this file.

An example call to this program is:

C:\\> trees dat1.txt dat2.txt dat3.txt dat4.txt output.txt

In the above call there are 4 input files and the last is the output file
for this program executable, trees.

/******************************************************************************/
 #include "trees.h"
 #include "bstree.h"
 #include "tttree.h"

/********************      D E C L A R A T I O N S    ***********************/
/*-----------------------------   MAIN   -----------------------------------*/
   bstnode *bst_root;    /* the root of the BST - pointer to a bst node-GLOBAL */
   tttnode *ttt_root;    /* the root of the TTT - pointer to a ttt node-GLOBAL */
			/**ttt_temp; */

   int 	FileCount = 0;   /* GLOBAL */

 /*-----------------------------   MAIN   -----------------------------------*/
   int main(int argc, char **argv )
   {
   
      FILE  	*input_fp1,          /* for input file */
         *stats_fp1;				/* for output file */
   
      int j;								/* For incrementation */
   
   
   #ifdef DEBUG
   /*-------------------------------- training wheels ---------------------------*/
   /*
   int argc = 5;
   
   char *argv[] = {"prog.EXE", "prg4dat1.txt", "prg4dat2.txt",
     "prg4dat3.txt", "prg4dat4.txt", "L_STATS.TXT"};
   
   char *argv[] = {"prog.EXE", "prg4dat1.txt",/* "M2.DAT",
     "M4.DAT", "M3.DAT", "M_STATS.TXT"};
   
   char *argv[] = {"prog.EXE", "prg4dat1.txt", "R5.DAT",
     "R6.DAT", "R9.DAT", "R_STATS.TXT"};
   */
   /*-------------------------------- training wheels ---------------------------*/
   #endif
   
   /******************************************************************************/
   									/* begin main */
      if (argc < 5)
      {
         fprintf(stderr,
                "\nYou did not enter the correct number of file arguements.\n\n");
         fprintf(stderr,
                "You must enter at least 5 command-line arguments \nfollowing ");
         fprintf(stderr, "the executable \"trees\".\n");
         fprintf(stderr, "\nFor example:\n\n");
         fprintf(stderr,
                "C:\\> trees input_1.dat input_2.dat input_3.dat input_4.dat output.dat\n");
         exit(1);
         exit(1);
      }
   
   /*----------------------------------------------------  open ouput stats file */
      if( (stats_fp1 = fopen(argv[5], "w")) == NULL)
      {                                            /* opens argv[argc] file */
         fprintf(stderr, "Error opening the output file for Comparisons Report.");
         exit(1);
      }
   /*-------------------------------------------------print header to stats file */
      fprintf(stats_fp1,
             "\n\t\t   Tree Investigation Project: Comparisons Report\n");
      fprintf(stats_fp1,
             "\t\t   Binary Search Tree (BST) and Two-Tree Tree (TTT)\n");
      fprintf(stats_fp1,
             "\t\t   Bettina McCormick, Assignment 3, CSIII - SPR 98\n\n");
   
      fprintf(stats_fp1,
             "\t\tThis report displays the # of compares and average seek time\n");
      fprintf(stats_fp1,
             "\t\t(compares / elements) for each file given as input.\n");
      fprintf(stats_fp1,
             "\t\tThe results for input that degenerates in a BSTree should\n");
      fprintf(stats_fp1,
             "\t\tclearly reflect no degeneration in the TTTree.\n\n");
      fprintf(stats_fp1,
             "  File      Elements  BST_Compares  BST_AvgSeekTime  ");
      fprintf(stats_fp1,
             "TTT_Compares  TTT_AvgSeekTime\n");
   
   
   /******************************************************************************/
      for (j = 1; j < 5; j++)
      {
         if( (input_fp1 = fopen(argv[j], "r")) == NULL)/* opens argv[1] file */
         {
            fprintf(stderr, "Error opening input file %d.", j);
            exit(1);
         }
         tree_comparison(&input_fp1, argv[j], &stats_fp1);
      }
   /******************************************************************************/
   
   /*--------------------------------------------------------------  close files */
      fclose(input_fp1);
      fclose(stats_fp1);
   
      printf("\nYour %d input files have successfully processed.", (argc - 1));
      printf("\n\nThe Comparison Report has been directed");
      printf("\nto your indicated ouput file, \"%s\".\n", argv[5]);
   
      return EXIT_SUCCESS;
   }
/********************************     end main     ****************************/

/*----------------------------------------------------------------   trees.c  */
/*------------------------------L O A D _ D A T A-----------------------------*\

 Purpose: This routine fills the array with the
			 file data for use later in determining average-seek time.

 Pre-Condition : Follow Parameters: file is open;
					  array of ints is initialized and the size of the file data

 Post-Condition: data is loaded into array of ints

 Return: EXIT_SUCCESS

 Comments:	Takes a pointer to array of integers that has been malloced to the
				file size and the pointer to the file:

\*----------------------------------------------------------------------------*/
   int load_data(int *R, FILE **fp)
   {
      int i = 0,
      data;
   
      while (fscanf(*fp, "%u\n", &data) == 1)
      {                            /* reads single char from file, saves as int */
         R[i] = data;
         i++;
      #ifdef DEBUG
      if (i == 507)
      printf("test");
      #endif
      }; /* end while */
      return EXIT_SUCCESS;
   } /* end load_data */

/*--------------------------G E T _ F I L E _ S I Z E-------------------------*\

 Purpose: This routine takes a pointer to a file and returns the number of
			 elements to be read from the file..

 Pre-Condition : Follow Parameters: file is open;

 Post-Condition: file is still open

 Return: the number of integers in the file

 Comments:  the file pointer is pointing to a text file of non-negative
				integers (one per line)

\*----------------------------------------------------------------------------*/
   int get_file_size(FILE **fp)
   {
      int filecount = 0,
      data;
   		  /* there is propably a better way to do this.. but I don't know it */
      while (feof(*fp)== FALSE)
      {                                /* cycles through file to get size of file */
         fscanf(*fp, "%d\n", &data);
         filecount++;
      }; /* end while */
   
      return filecount;
   } /* end get_file_size */


/*----------------------T R E E _ C O M P A R I S O N-------------------------*\

 Purpose: This routine calls the BST ans TTT routines: it builds and searches
			 both trees and counts the compares: it writes this data to the output
			 file. This also creates 2 test files - one for each typr of tree -
			 the form of "inorder" traversal is written to these test files to
			 check the tree - I left this in for curiousity sake (so the data
			 of the last file will be output "inorder" to these files).

 Pre-Condition : Follow Parameters: files passed are open;

 Post-Condition: Files passed are still open; data has been processed and
					  the Comparisons Report has been put to output file.

 Return: EXIT_SUCCESS

\*----------------------------------------------------------------------------*/
   int tree_comparison(FILE **in_fp, char *filename, FILE **out_fp)
   {
      int 	*data_holder;   /* array of integers to contain file data - space
   								 to be malloced later after file size determined */
      int 	filesize;       /* to count elements in file */
   
      int    bst_cmprs = 0,  /* number of compares when using BST */
      ttt_cmprs = 0;  /* number of compares when using TTT */
   
   
   #ifdef DEBUG
   int    f_length,		 /* length of filename */
   		l = 0;              /* for formatting */
   #endif
   
      int			i;              /* for incrementation */
   
      float 	bst_avg = NADA, /* BST average seek-time: compares / elements */
      ttt_avg = NADA; /* TTT average seek-time: compares / elements */
   
      FILE *BST_test_fp1,  /* my test file for BST: data in order is output to
         					  this file to check the tree */
         *TTT_test_fp1;  /* my test file for TTT: data in order is output to
   							  this file to check the tree */
   
   /******************************************************************************/
   /*---------------------------------------------------------open my test files */
      if( (BST_test_fp1 = fopen("last_BST.txt", "w")) == NULL)
      {
         fprintf(stderr, "Error opening my test file for writing.");
         exit(1);
      }
      if( (TTT_test_fp1 = fopen("last_TTT.txt", "w")) == NULL)
      {
         fprintf(stderr, "Error opening my test file for writing.");
         exit(1);
      }
   
   /*---------------------------------------------------------  get size of file */
      FileCount++;
      filesize = get_file_size(in_fp);
      rewind(*in_fp);
   
   #ifdef DEBUG
   printf("\n%d", filesize);
   #endif
   /*--------------------------------   malloc space for array to hold file data */
      if ((data_holder = (int *) malloc(filesize * sizeof(int))) == NULL)
      {
         printf("Not enough memory to allocate array buffer\n");
         exit(1);
      } /* end if */
   /*-----------------------------------------------------  load data into array */
      load_data(data_holder, in_fp);
   
   /******************************************************************************/
   						/* start binary search tree */
   /*-------------------------------------------------  build binary search tree */
      bst_root = NULL;
      for (i = 0; i < filesize; i++)
      {
         bst_root = bst_insert(bst_root, data_holder[i]);
      }
   /*---------------------------   search binary search tree - average seek time */
      for (i = 0; i < filesize; i++)
      {
         bst_search(bst_root, data_holder[i], &bst_cmprs);
      }
   /*---------------------------------------   display tree inorder to test file */
      bst_inorder(bst_root, &BST_test_fp1);
   /*-------------------------------------------------   free binary search tree */
      bst_free(bst_root);
      bst_root = NULL;
      free(bst_root);
   #ifdef DEBUG
   bst_inorder(bst_root, &BST_test_fp1);
   #endif
   						/* end binary search tree */
   /******************************************************************************/
   						/* start two three tree */
   /*-----------------------------------------------------  build two three tree */
   
      ttt_root = NULL;
      for (i = 0; i < filesize; i++)
      {
         ttt_root = ttt_insert(ttt_root, data_holder[i]);
      }
   
   
   /*------------------------------   search two three tree - average seek time */
   
      for (i = 0; i < filesize; i++)
      {
         ttt_search(ttt_root, data_holder[i], &ttt_cmprs);
      }
   
   /*----------------------------------------------------------   display TTTree */
      ttt_traverse(ttt_root, &TTT_test_fp1);
   
   /*-----------------------------------------------------   free two three tree */
   
   
   						  /* end two three tree */
   /******************************************************************************/
   								 /* stats */
   /*-------------------------------------  calculate avg seek time - BOTH trees */
      bst_avg = bst_cmprs / filesize;
      ttt_avg = ttt_cmprs / filesize; 
   /*------------------------------------------------------  print stats to file */
   #ifdef DEBUG
   f_length = strlen(filename);
   l=0;
   if (f_length <= 12)
   	l = (12 - f_length);
   #endif
      fprintf(*out_fp, "%-12s%8d%12d%16.2f%15d%16.2f\n",
             filename,filesize,bst_cmprs, bst_avg, ttt_cmprs, ttt_avg);
   										/* stats */
   /******************************************************************************/
      free(data_holder);                            /* free space for data holder */
   /******************************************************************************/
   
   
      fclose(BST_test_fp1);
      fclose(TTT_test_fp1);
      return EXIT_SUCCESS;
   } /* end tree_comparison */


