/* trees.h
/******************************************************************************\
		 Bettina McCormick, April 1998, CSIII, Dr. Leeson, Assignment #3

		 Tree Investigation Project  - Due Date: Wednesday April 29, 1998

		 Main Program:  trees.c  Version 2.1 - last updated  April 27, 1998

	 This program investigates two different tree structures:
	 the Binary Search Tree (BST) and the Two-Three Tree (TTT).

\******************************************************************************/

/************************   WHAT THIS PROGRAM DOES   **************************\

This program will open a text file of non-negative
integers (one per line) and insert them into a binary search tree.
It will then look up each of the integers and after finding
them all, will output the total number of data compares made to
the output file specified.

It will then rewind the a text file of non-negative
integers (one per line) and insert them into a 2-3 tree.  It
will then look up each of the integers and after finding them
all, will output the total number of data compares made to
the output file specified.

\******************************************************************************/
/***************************   INPUT SPECIFCATIONS   **************************\

The input for this program ia a file or files containing non-negative
integers (one per line).  Enter as many files as you wish on the command line.
However, the last arguement you enter must be the name of the your output file.
The Comparisons Report will be written to this file.

An example call to this program is:

C:\\> trees dat1.txt dat2.txt dat3.txt dat4.txt output.txt

In the above call there are 4 input files and the last is the output file
for this program executable, trees.

/******************************************************************************/
/**********************************  trees.h  *********************************/
 #include "bstree.h"
 #include "tttree.h"

 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>

 /* #define DEBUG */
 #define TRUE                1
 #define FALSE               0
 #define NADA				    -1

/***********************     P R O T O T Y P E S     **************************/

/*------------------------------L O A D _ D A T A-----------------------------*\

 Purpose: This routine fills the array with the
			 file data for use later in determining average-seek time.

 Pre-Condition : Follow Parameters: file is open;
					  array of ints is initialized and the size of the file data

 Post-Condition: data is loaded into array of ints

 Return: EXIT_SUCCESS

 Comments:	Takes a pointer to array of integers that has been malloced to the
				file size and the pointer to the file:

\*----------------------------------------------------------------------------*/
   int load_data(int *R, FILE **fp);

/*--------------------------G E T _ F I L E _ S I Z E-------------------------*\

 Purpose: This routine takes a pointer to a file and returns the number of
			 elements to be read from the file..

 Pre-Condition : Follow Parameters: file is open;

 Post-Condition: file is still open

 Return: the number of integers in the file

 Comments:  the file pointer is pointing to a text file of non-negative
				integers (one per line)

\*----------------------------------------------------------------------------*/
   int get_file_size(FILE **fp);

/*----------------------T R E E _ C O M P A R I S O N-------------------------*\

 Purpose: This routine calls the BST ans TTT routines: it builds and searches
			 both trees and counts the compares: it writes this data to the output
			 file. This also creates 2 test files - one for each typr of tree -
			 the form of "inorder" traversal is written to these test files to
			 check the tree - I left this in for curiousity sake (so the data
			 of the last file will be output "inorder" to these files).

 Pre-Condition : Follow Parameters: files passed are open;

 Post-Condition: Files passed are still open; data has been processed and
					  the Comparisons Report has been put to output file.

 Return: EXIT_SUCCESS

\*----------------------------------------------------------------------------*/
   int tree_comparison(FILE **in_fp, char *filename, FILE **out_fp);




