/* ************************************************************************** *\
       Bettina McCormick, March 1998, CSIII, Dr. Leeson, Assignment #2

       Hash Table Comparison Project  - Due Date: March 11, 1998

       Main Program:  hashes.c Version 5.1 - last updated March 5, 1998

    This program investigates a hash table. The input will be 1000
      positive integers and the most important operation on this collection
      of data will be searching. There will be no duplicates in the data.
      Two methods will be compared.

    An open hash table:  Table size is to be the largest prime number
      less than 2000.  Collision reslution will be handled by simple
      linked lists.  Array will contain pointers to nodes and nodes will
      be structs with integer data and a nextNode pointer.  The hash
      function will be simple, x hashes to x MOD the chosen prime.

    A closed hash table:  Array sizes chosen as above with ~1000
      extra slots for the overflow.  Bin size should be 5 with
      collisions handled by circling through the bin and then going
      to the sequential overflow area.

\* ************************************************************************** */
#include "hashes.h"
#include "ohash.h"
#include "chash.h"

/*****************************   begin main   *********************************/

   int main(int argc, char **argv)
   {
   /****************************    declarations     **************************/
   
      int tablesize1500 = 0,
      tablesize2000 = 0,
      tablesize2500 = 0;
   
   
   /***************************************************************************/
   
   
   
      if (argc < 2)
      {
         printf("You did not enter the file arguement.");
         exit(1);
      }; /* end if */
   
   
      tablesize1500 = PrimeSieve(RANGE1500);
      tablesize2000 = PrimeSieve(RANGE2000);
      tablesize2500 = PrimeSieve(RANGE2500);
   
      OpenHash(argv[1], tablesize1500);
      OpenHash(argv[1], tablesize2000);
      OpenHash(argv[1], tablesize2500);
   
      ClosedHash(argv[1], tablesize1500);
      ClosedHash(argv[1], tablesize2000);
      ClosedHash(argv[1], tablesize2500);
   
   
      return EXIT_SUCCESS;
   }

/******************************************************************************/

   int PrimeSieve(int prange)
   /*  Takes the largest range to search (arg 1).  Returns the largest
    prime in the range */
   {
      char *E;
      long int i, j, P;
   
      if ((E = (char *) malloc(prange * sizeof(char))) == NULL)
      {
         printf("Not enough memory to allocate prime array buffer\n");
         exit(1);
      } /* end if */
   
      for (i = 0; i < prange; i++)
      {                                /* initializes array to all 1's */
         E[i] = '1';
      };
   
      for (i = 2; i < prange; i++)
      {                                /* mark non-primes = to 0 */
         j = i;
         if (E[j] == '1')
            j += i;
         while (j <= prange)
         {
            E[j] = '0';
            j += i;
         }; /* end while */
      }; /* end for i */
      for (i = 2; i < prange; i++)
      {                               /* find the largest prime */
         if (E[i] == '1')
            P = i;
      };
   
      free(E);
   
      return P;
   } /* end PrimeSieve */

/********************************     end main     ****************************/


