/* *************************************************************************
   Bettina McCormick, Spring 1999, Dr. Duminda Wijesekera,  COP 4600

   Simulator Project    Original Design:  Dr. David Workman
   Revised  Tim Hughey  Mark Stephens

   
   OBJECTIVE 1

   obj1.c - Version 1.8 - created January 18, 1999
				    - last updated April 28, 1999


	3rd revision - submitted for obj3
	4th revision - submitted for obj4/5
****************************************************************************/
/***************************************************************************
							my index of obj 1 funtions
void
Add_event(struct simtime *time,  int event, int agent )

void
Load_events(void)

void
Write_event( int event, int agent, struct simtime *time )

void
Interrupt(void)
****************************************************************************/

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "osdefs.h"
#include "externs.h"

/*
#define DEBUG
#define DEBUG_LIST
*/

#ifdef DEBUG
   FILE *dbg1_fp;
	FILE *dbglist_fp;
#endif

#define   EVENTNUM    8    /* max number of events - for 'for-looping' */


/******************  M Y   F U N C T I O N S ******************************/
   void
   My_strupr(char *this_str)
   /* ----------------------------------------------------------------------- */
   /*     This function changes a string of chars to upper case.  Written     */
   /*     because it is not in the libraries available and more convenient    */
   /*     than using the str_lwr provided by the simulator.c file             */
   /* ----------------------------------------------------------------------- */
   {
      while(*this_str)
      {
			*this_str = toupper(*this_str);
         this_str++;
      }
   } /* end My_strupr */


void Mylist(void)
	/* ----------------------------------------------------------------------- */
	/*    This function prints the new_events list to my list debug file.      */
	/* ----------------------------------------------------------------------- */
{
		static int count = 0;
		struct event_type *tracer3;
		int cnt = 0;

		#ifdef DEBUG_LIST
/* to a file ***********************************************************
		if( (dbglist_fp = fopen("dbg_list.dat","a")) == NULL  )
		{ printf("dbg_list.dat file did not open! \n");
			exit(0);
		}


		count++;
		fprintf(dbglist_fp,"%d time to print new_events list\n", count);
		tracer3 = new_events;
		while(tracer3 != NULL)
		{
		cnt++;
		fprintf(dbglist_fp,"%d node event = %d; agent = %d; sec = %u; nsecs = %u\n",
		 cnt,tracer3->event, tracer3->agent, tracer3->time.seconds, tracer3->time.nanosec);
		
		tracer3 = tracer3->next;
		} /* end while
		fprintf(dbglist_fp,"\n");

*******************************************************/
		count++;
		printf("%d time to print new_events list\n", count);
		tracer3 = new_events;
      while(tracer3 != NULL)
		{
		cnt++;
		printf("%d node event = %d; agent = %d; sec = %u; nsecs = %u\n",
		 cnt,tracer3->event, tracer3->agent, tracer3->time.seconds, tracer3->time.nanosec);
		
      tracer3 = tracer3->next;
		} /* end while */
		printf("\n");


      #endif
}/* end Mylist */

/******************************************************************************/

   void
	Add_event(struct simtime *time,  int event, int agent )
   /* ----------------------------------------------------------------------- */
   /*     This function inserts a future event in the list new_events in      */
   /*     the proper time sequence. new_events points to the end of the       */
   /*     list having the smallest time ( defined by the function Cmpr_time)  */
   /* ----------------------------------------------------------------------- */
   {
      #define ZERO   0
      #define TRUE   1
      #define FALSE  0
   
      int   cmpr_value,
      stopflag,
      i;
   
      struct event_type *ptr2node, *tracer, *prevnode;
   
      static flag = FALSE;
   
      flag++;
   #ifdef DEBUG
		printf("adding node %d\n\n", flag);

		printf("%%time coming in sec=%u  nano sec=%u \n\n",
		time->seconds, time->nanosec);

   #endif
      if ((ptr2node =
         (struct event_type*) malloc(sizeof(struct event_type))) == NULL)
      {
         printf("Not enough memory to allocate node\n");
         exit(1);
      }    /* end if */
   
      ptr2node->event = event;      /* fill new node */
      ptr2node->agent = agent;
      ptr2node->time = *time;
      ptr2node->prev = NULL;
      ptr2node->next = NULL;
   
      if (new_events == NULL)
      {                             /* if list is empty, make head of list */
         new_events = ptr2node;
      }
      else if ((new_events->next == NULL) && (new_events != NULL) )
      {                             /* if only one node in list, compare time 
                                       and put head or end */
         cmpr_value = Cmpr_time(ptr2node, new_events);
         if (cmpr_value < ZERO) 
                                     /* if node less than new_events, 
                                       insert at head */
         {
            ptr2node->next = new_events;
            new_events->prev = ptr2node;
            new_events = ptr2node;
         } /* end if cmpr_value < ZERO */
         else if ((cmpr_value == ZERO) || (cmpr_value > ZERO))
                                    /* if node greater or equal than new_events, 
                                       insert at end */
         {
            ptr2node->prev = new_events;
            new_events->next = ptr2node;
         } /* end if cmpr_value >= ZERO */
      } /* end if only one node in list */
      else 
      {                             /* else more 2 or more nodes in list, 
                                       compare time and insert properly */
      
         cmpr_value = Cmpr_time(ptr2node, new_events);
         tracer = new_events;
         prevnode = new_events;
      
         if (cmpr_value < ZERO) 
         /* if node less that new_events, insert here */
         {
            ptr2node->next = tracer;
            tracer->prev = ptr2node;
            new_events = ptr2node;
         } /* end if cmpr_value < ZERO */
         else 
         {
            while (((cmpr_value == ZERO) || (cmpr_value > ZERO)) && 
                  (tracer->next != NULL))
                                    /* if node equal to new_events or greater 
                                       and not end of list, seacrh to insert */
            {
               tracer = tracer->next;
               prevnode = tracer->prev; 
               cmpr_value = Cmpr_time(ptr2node, tracer);
            }  
         
            if (tracer->next == NULL)
            {   /* if end of list */
               if (((cmpr_value == ZERO) || (cmpr_value > ZERO)))
               {
                  ptr2node->prev = tracer;
                  tracer->next = ptr2node;
               } /* end if greater than or equal */
               else
               {
                  ptr2node->next = tracer;
                  ptr2node->prev = prevnode;       
                  prevnode->next = ptr2node;
                  tracer->prev = ptr2node;
               }/* end else */
            } /* end if end of list */
            else                          /* else not end of list, insert */
            {
            
               ptr2node->next = tracer;
               ptr2node->prev = prevnode;       
               prevnode->next = ptr2node;
               tracer->prev = ptr2node;
            }
         } /* end else not < ZERO */
      
      #ifdef DEBUG
      printf("i finished adding event %d\n\n", flag);
      #endif
      } /* end if more than one node in list */
   
   
   
   #ifdef DEBUG
		printf("inside Add_events: node %d event=%d -obj1\n",
			flag, ptr2node->event );
		printf("inside Add_events: node %d agent=%d -obj1\n",
			flag, ptr2node->agent );
      printf("inside Add_events: node %d time=%u nsec, %u sec -obj1\n\n",
			flag, ptr2node->time.nanosec, new_events->time.seconds);
   Mylist();
	#endif

	} /* end  Add_event */


   void
	Load_events(void)
   /* ----------------------------------------------------------------------- */
   /*     This function initializes the event list (new_events) from the      */
   /*     file logon.dat.  This file normally contains only LOGON events      */
   /*     for all terminals.  However, for debugging purposes, logon.dat      */
   /*     can contain events of any type.                                     */
   /* ----------------------------------------------------------------------- */
   {
   
      char  load_ident[15], temp[4], lwr_temp[5];  /* for scanned data */
      int   i, n,       /* for incrementation */
      count = 0,        /* to trak add_events*/
      E,                /* event */
      A;                /* agent */
      struct simtime tmp_time, *ptr_time;       /* struct and pointer to it*/
      unsigned long  tmp_t;
	#ifdef DEBUG
	/*
		if( (dbg1_fp = fopen("DEBUG/dbg_1.dat","w")) == NULL  )
      { printf("dbg_1a.dat file did not open! \n");
         exit(0);
		}
		fprintf(dbg1_fp,  "This is my debugging file. \n\n");
      */
	#endif
      if( (logonfp = fopen("logon.dat","r")) == NULL  )/* open logon file */
      { printf("LOGON.DAT file did not open! \n");
         exit(0);
      }
      count=0;
		while( fscanf(logonfp,"%s",load_ident) != EOF ) /* scan til end of file */
      {
			count++;
			if (strlen(load_ident) == 0)
         { printf("identifier is empty \n\n");
            exit(0);
         }
      
         if (isalpha(load_ident[0]))
         {
            My_strupr(load_ident);  /* change case to upper */
         #ifdef DEBUG
			printf("ident= %s load_events-obj1\n", load_ident);
         #endif
            if( load_ident[0] == 'U')
            {    /* if starts with 'U' */
               for (i=1;i<4;i++)
                  temp[i-1]=load_ident[i];
               temp[4]='\0';
               A = atoi(temp);   /*set agent = to 3 digit number after 'U' */
            #ifdef DEBUG
				printf("Agent=%d load_events-obj1\n", A);
            #endif
            } /* end if starts with 'U' */
            else
            {
            
               for (i = 0; i < EVENTNUM; i++)
               {                          /* if event */
               
                  if( !strcmp(load_ident,eventidtab[i]))
                  {
                     E = i;
                  
                  #ifdef DEBUG
                  printf("Event=%d load_events-obj1\n", E);
                  #endif
                  }/* end if event */
               }/* end for each event in event id table */
            
            }   /* end else ifs for event */
         #ifdef DEBUG
         printf("Event=%d load_events-obj1\n", E);
         #endif
                           /* still is alpha but not event and not 'U' */
            for (i = 0; i < DEVSIZE; i++)
            {                        /* if device */
            
               if( !strcmp(load_ident,devtable[i].devid))
               {
                  A = TRMSIZE + (i + 1);
               
               #ifdef DEBUG
               printf("Agent=%d load_events-obj1\n", A);
               #endif
               }/* end if device */
            }/* end for each event in event id table */
         
         }/* end if isalpha */
         else                        /* else not alpha */
         {
            tmp_t = atof(load_ident);
         #ifdef DEBUG
         printf("LogonT=%u load_events-obj1\n", tmp_t);
         #endif
            ptr_time = &tmp_time;    /* set pointer to address of struct*/
            ptr_time->seconds = 0;   /* initialize struct to zero */
            ptr_time->nanosec = 0;   /* initialize struct to zero */
         
            Convrt_time(ptr_time, tmp_t);
         #ifdef DEBUG
         printf("seconds=%u\tnanosec=%u load_events-obj1\n",
         ptr_time->seconds, ptr_time->nanosec);
         #endif
         }/* end else not alpha */
      
         if (count==3)
         {
				Add_event(ptr_time, E, A);
				count = 0;
         }
      }/* end while */

	#ifdef DEBUG
			printf("end Load_events -obj1\n");
			#endif
	} /* end  Load_events */


   void
   Write_event( int event, int agent, struct simtime *time )
   /* ----------------------------------------------------------------------- */
   /*         This function writes an event to *.OUT  with the format:        */
   /*   "  EVENT  AGENT  TIME (HR:xxxxxxxx MN:xx SC:xx MS:xxx mS:xxx NS:xxx )"*/
   /*   You will have to convert the nanosec field to MS, mS and NS.  The     */
   /*   seconds field will have to be converted to HR, MN and SC.             */
   /* ----------------------------------------------------------------------- */
   {
      int  i, j;
      unsigned long     sc, ns;
      int            hr, mn, mls, mcs;
   
   
   
      hr =  (time->seconds / (MIN * MIN));
      mn =  ((time->seconds - (hr * (MIN * MIN))) / MIN);
      sc =  (time->seconds - (hr * (MIN * MIN)) - (mn * MIN));
   
      mls =  (time->nanosec / MSEC);
      mcs =  ((time->nanosec - (mls * MSEC) ) / mSEC);
      ns  =  (time->nanosec - (mls * MSEC) - (mcs * mSEC));
   
      for (i = 0; i < EVENTNUM; i++)
      {
         if (event == i)
         {
            if (i == 6)
            {
               fprintf(simout, "  SEGFAU ");
            
            }
            else if (i == 7)
            {
               fprintf(simout, "  ADRFAU ");
            }
            else
            {
               fprintf(simout, "  %-7s",  eventidtab[i]);
            }
         }
      }
      if ((event == 6) || (event == 7))
      {
         fprintf(simout, "MEM    ");
      }
      else
      {
         for (i = 0; i < (TRMSIZE + 1); i++)
         {
            if (agent == i)
               fprintf(simout, "U%03d   ",  agent);
         }
         for (j = 0; j < DEVSIZE; j++)
         {
            if (agent == (j + TRMSIZE + 1))
               fprintf(simout, "%s   ",  devtable[j].devid);
         }
      }
      fprintf(simout, "HR:%8u MN:%2u SC:%2u MS:%3u mS:%3u NS:%3u\n",
             hr, mn, sc, mls, mcs, ns);
   
   #ifdef DEBUG
   printf("Write_event node event = %d -obj1\n",  event);
   printf("Write_event node agent = %d -obj1\n",  agent);
   printf("Write_event node time=%u nsec, %u sec -obj1\n\n",
   time->nanosec, time->seconds);
   #endif
   
   } /* end  Write_event */


   void
   Interrupt(void)
   /* ----------------------------------------------------------------------- */
   /*           This function:                                                */
   /*              (1)  removes an event from new_events                      */
   /*              (2)  sets CLOCK, AGENT and EVENT                           */
   /*              (3)  deallocates the event element                         */
   /*              (4)  writes the event to  *.OUT                            */
   /*              (5)  Copies CPU.mode and CPU.pc into Oldstate.             */
   /*              (6)  Copies NewState into CPU.mode and CPU.pc              */
   /* ----------------------------------------------------------------------- */
   {
      struct event_type *tracer2;
      struct simtime 	tclock;
		int count2 = 0;   /* for debugging purposes */

   #ifdef DEBUG
	printf("Enter Interrupt -obj1\n");
		Dev_rblist();
   #endif
      tracer2 = new_events;
   
      count2++;
	 tclock = CLOCK;
	#ifdef DEBUG
	 printf("***interrupt iCLOCK.S=%d  iCLOCK.N=%u***\n",
			tclock.seconds, tclock.nanosec);
	#endif
      Write_event(new_events->event, new_events->agent, &new_events->time);
   
      CLOCK = new_events->time;  /* set externs */
      AGENT = new_events->agent;
      EVENT = new_events->event;
   
      new_events = new_events->next;   /* advance the list */
	 free(tracer2);                   /* free the space */


      OldState.mode =  CPU.mode;       /* set externs */
      OldState.pc =  CPU.pc;
      CPU.mode = NewState.mode;
      CPU.pc = NewState.pc;
   #ifdef DEBUG
		printf("old.mode=%u, old.pc=%u interupt-obj1\n", OldState.mode,OldState.pc);
      printf("new.mode=%u, new.pc=%u interupt-obj1\n\n", NewState.mode,NewState.pc);
   #endif
	#ifdef DEBUG_LIST
fprintf(dbglist_fp,"\n\n   Interupt after\n");
		Mylist();
	#endif
	#ifdef DEBUG
		Dev_rblist();
   printf("Exit Interrupt -obj1\n\n");
   #endif
   }  /* end Interupt */


/* *************************************************************************
   Bettina McCormick, February 1999, Dr. Duminda Wijesekera,  COP 4600
   End   OBJECTIVE 1
****************************************************************************/
