/* *************************************************************************
   Bettina McCormick, Spring 1999, Dr. Duminda Wijesekera,  COP 4600
   Simulator Project    Original Design:  Dr. David Workman
	Revised  Tim Hughey  Mark Stephens

   OBJECTIVE 5
	obj5.c - Version 1.1    - created April 15, 1999
					  - last updated April 27, 1999

****************************************************************************/
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "osdefs.h"
#include "externs.h"

/*************************** Objective 5 functions **************************/

   void
	Calc_stats(void)
	/* ------------------------------------------------------------------------- */
	/*    This function computes all simulation statistics and stores them       */
	/*    in the appropriate variables and data structures for display.          */
	/*    It is called by Wrapup().                                              */
	/* ------------------------------------------------------------------------- */
	{

		int j;      /* for incrementation */
		struct simtime mytmp;   /* for calculation */
		for (j = 0; j < DEVSIZE; j++)
		{
			mytmp = CLOCK;    /* idle time */
			Diff_time(&(devtable[j].busy), &mytmp);
			devtable[j].idle = mytmp;


			mytmp.seconds = 0;   /* response time */
			mytmp.nanosec = 0;
			Add_time(&(devtable[j].busy), &mytmp);
			Add_time(&(devtable[j].qwait), &mytmp);
			Ave_time(&(devtable[j].response), &mytmp, devtable[j].served);


			mytmp = CLOCK;      /* utilization time */
			devtable[j].utilize = Divd_time(&(devtable[j].busy), &mytmp) * 100;
		} /* end for devices */


		for (j = 0; j < TRMSIZE && termtable[j] != NULL; j++)
		{
			Add_time(&(termtable[j]->tlogon), &TOTLOGON);
			Add_time(&(termtable[j]->trun), &TOTRUN);
			Add_time(&(termtable[j]->tready), &TOTWAIT);
			Add_time(&(termtable[j]->tblocked), &TOTBLKED);

			mytmp = termtable[j]->tblocked;
			Add_time(&(termtable[j]->trun),&mytmp);
			termtable[j]->efficncy = Divd_time(&mytmp, &(termtable[j]->tlogon)) * 100;
		} /* end for terminals */


		Ave_time(&AVELOGON, &TOTLOGON, j);  /* averages */
		Ave_time(&AVERUN, &TOTRUN, j);
		Ave_time(&AVEWAIT, &TOTWAIT, j);
		Ave_time(&AVEBLKED, &TOTBLKED, j);

		mytmp = CLOCK; /* CPU stats */
		CPU.utilize = Divd_time(&(CPU.busy), &mytmp) * 100;
		Diff_time(&(CPU.busy), &mytmp);
		CPU.idle = mytmp;
		mytmp = CPU.busy;
		Add_time(&(CPU.qwait), &mytmp);
		Ave_time(&(CPU.response), &mytmp, CPU.served);

	} /* end Calc_stats */


/* *************************************************************************
	Bettina McCormick, Spring 1999, Dr. Duminda Wijesekera,  COP 4600
	End   OBJECTIVE 5
****************************************************************************/

