/* BITSPART.C
/*
/*   SSSS    OOOO   U    U  RRRRR    CCCC   EEEEEE
/*  S       O    O  U    U  R    R  C    C  E
/*  S       O    O  U    U  R    R  C       E
/*   SSSS   O    O  U    U  RRRRR   C       EEE
/*       S  O    O  U    U  R  R    C       R
/*       S  O    O  U    U  R   R   C    C  R
/*   SSSS    OOOO    UUUU   R    R   CCCC   REEEEE
/*****************************************************************************\
			   Fire, Earth, and Wind
	   (a.k.a. Hai Nguyen, Bettina McCormick  & Rob Konczynski, Jr.)

	      April 1998, COP 3402 - Systems, Assignment #3

		   Pass 2  - Due Date: April 27, 1998

 *------------------------   BIT STUFF FUNCTIONS  ----------------------------*

\******************************************************************************/						



/*---------------------- F L I P _ T H E _ B I T   ----------------------------\

 Purpose:  flips the bit that is passed on int the char that is passed

 Pre-Condition : <none> Follow Parameters

 Post-Condition: char that was passed now has the bit indicated in pass flipped.

 Return: void

\-----------------------------------------------------------------------------*/
void flip_the_bit (int b, char *a)
{
	int bits[CHAR_BIT + 1] = { 0x0,   /*the bit representation of each bit*/
				   0x1,0x2,0x4,0x8,
				   0x10,0x20,0x40,0x80};

	*a = *a | bits[b];
} /* end flip_the_bit */



/*-------------------------   S E T _ B I T S   -------------------------------\

 Purpose:  used in fmt2 -  returns a char with the bits set for the
	   two hex digits passed;
	   the first hex value is R2, the second is R1

 Pre-Condition : <none> Follow Parameters

 Post-Condition:

 Return: char

 Comment: This is the Bettina-brute-force way
	- my hats off to Hai and his slick "shift the bits"!

\-----------------------------------------------------------------------------*/
char set_bits (int r, int l)
{
	char a = 0;	/* char to be returned */

	int 	i,  	/* for incrementation */
		bit_val[16][4] = { {NADA, NADA, NADA, NADA}, {1, NADA, NADA, NADA},
				{2, NADA, NADA, NADA}, {1, 2, NADA, NADA},
				{3, NADA, NADA, NADA}, {1, 3, NADA, NADA},
				{2, 3, NADA, NADA},    {1, 2, 3, NADA},
				{4, NADA, NADA, NADA}, {1, 4, NADA, NADA},
				{2, 4, NADA, NADA},    {1, 2, 4, NADA},
				{3, 4, NADA, NADA},    {1, 3, 4, NADA},
				{2, 3, 4, NADA},       {1, 2, 3, 4}
			      };


  for (i = 0; i < 4; i++)
  {
	 if (bit_val[r][i] != NADA)
	 {
		 flip_the_bit(bit_val[r][i], &a);
	 }
	 if (bit_val[l][i] != NADA)
	 {
		 flip_the_bit((bit_val[l][i] + 4), &a);
	 }
  }
  return a;
} /* end set_bits */

/*---------------------------  B I T _ P R I N T ------------------------------\

 Purpose:  prints bits of a char to a file

 Pre-Condition : <none> Follow Parameters

 Post-Condition: bit representation of a char are printed to a file

 Return: void

\-----------------------------------------------------------------------------*/
void bit_print (FILE **fp, char a)
{
	int i;
	char n = sizeof( char) * CHAR_BIT;
	char mask = 1 << (n - 1);

	for (i = 1; i <= n; ++i)
	{
		putc((((a & mask) == 0) ? '0' : '1'), *fp);
		a <<=1;
	}
} /* end bit_print */

/*------------------------  END BIT STUFF FUNCTIONS  -------------------------*/
/* submitted by Bettina */
