/* FM12PART.C
/*
/*   SSSS    OOOO   U    U  RRRRR    CCCC   EEEEEE
/*  S       O    O  U    U  R    R  C    C  E
/*  S       O    O  U    U  R    R  C       E
/*   SSSS   O    O  U    U  RRRRR   C       EEE
/*       S  O    O  U    U  R  R    C       R
/*       S  O    O  U    U  R   R   C    C  R
/*   SSSS    OOOO    UUUU   R    R   CCCC   REEEEE
/*****************************************************************************\
			   Fire, Earth, and Wind
	   (a.k.a. Hai Nguyen, Bettina McCormick  & Rob Konczynski, Jr.)

	      April 1998, COP 3402 - Systems, Assignment #3

		   Pass 2  - Due Date: April 27, 1998

 *---------------------- FORMATS 1 & 2  FUNCTIONS  ---------------------------*

\******************************************************************************/						


/*-------------------------------- F M T 1  -----------------------------------\

 Purpose: This routine is used by pass2 to process format 1.

 Pre-Condition : <None>  Follow Parameters

 Post-Condition: object code is set to instruction code;
		 object code in hex and bit representation are printed to a
		 temporary file

 Return: void

\-----------------------------------------------------------------------------*/
void fmt1(FILE **fp, struct ot_entry *ot, int opidx)
{
  objcode[0] = ot[opidx].ot_opcode;
  fprintf(*fp, "%3d   %3.2X%3.2c%3.2c%3.2c     ",
		 lineno, objcode[0], BLANK, BLANK, BLANK);
  bit_print(&temp_fptr, objcode[0]);
  fprintf(*fp, " \n");
}/* end of fmt1 */

/*------------------------------- F M T 2 -------------------------------------\

 Purpose:  This routine is used by pass2 to process format 2.
	   takes the file pointer to the temp file, the optab, op index,
	   the operator, operand to be parsed, and the symtab;
	   creates object code for the instruction and prints it to
	   the temp file in hex and binary.

 Pre-Condition : <none> Follow Parameters

 Post-Condition: object code is set to instruction code and register values;
		 object code in hex and bit representation are printed to a
		 temporary file

 Return: void

\-----------------------------------------------------------------------------*/
void fmt2(FILE **fp, struct ot_entry *ot, int opidx,
	  char  opr[OP_LENGTH + 1], char ond[OPND_LENGTH + 1], 
	  struct st_entry *st)
{
	char *p,                      /* pointer to char for strtok */
	     R1[OPND_LENGTH + 1],     /* register one parsed from operand */
	     R2[OPND_LENGTH + 1],     /* register two parsed from operand */
	     delim[] = " ,";          /* delimiters for parsing opnd */

	int  svc_flag = FALSE,	      /* flag for SVC oper - special case */
	     shift_flag = FALSE,      /* flag for SHIFT oper - special case */
	     R2_flag = FALSE,	      /* flag for register two */
       	     r1_val,		      /* value for register one - special case */	
	     r2_val,	 	      /* value for register two - special case */	
	     r1_index = 0,	      /* index for register one */
             r2_index = 0;	      /* index for register two */

	  if (opr[1] == 'V')	      /* if opr is SVC - special case */	
	  {
		svc_flag = TRUE;
	  }
	  else if ((strlen(opr) == 6) && (opr[5] == 'L') || (opr[5] == 'R'))
	  {			      /* if opr is SHIFT - special case */
		shift_flag = TRUE;
	  }

	  if ((p = strtok(ond, delim)) != NULL) /* parse operand for R1, R2 */
		strcpy(R1, p);
	  if ((p = strtok(NULL, delim)) != NULL)
	  {
		R2_flag = TRUE;
		strcpy(R2, p);
	  }

	  r1_index = symtab_hash(R1); 	/* get index for R1 */ 
			/* precondition: registers are loaded in symtab first */
	  if (R2_flag == TRUE)
		r2_index = symtab_hash(R2);   /* get index for R1 */ 
			/* precondition: registers are loaded in symtab first */

	  objcode[0] = ot[opidx].ot_opcode;

/*--------  set 2nd byte of object code: decipher register values, etc--------*/
	  if (R2_flag == TRUE)
	  {
		if (shift_flag == TRUE)
		{			/* if opr is SHIFT - special case */
			r2_val = (atoi(R2) - 1);
			objcode[1] = set_bits(r2_val, st[r1_index].st_value);
		}
		else
		{
			objcode[1] = set_bits(st[r2_index].st_value, 
						st[r1_index].st_value);
		}
	  }
	  else
	  {
		if (svc_flag == TRUE)
		{			/* if opr is SVC - special case */
			r1_val = atoi(R1);
			objcode[1] = set_bits(FALSE, r1_val);
		}
		else
		{
			objcode[1] = set_bits(FALSE, st[r1_index].st_value);
		}
	  }

/*-------------- print object code in hex and bit form to temp file ----------*/
	  fprintf(*fp, "%3d   %3.2X%3.2X%3.2c%3.2c     ",
		lineno, objcode[0], objcode[1], BLANK, BLANK);
	  bit_print(&(*fp), objcode[0]);
	  fprintf(*fp, " ");
	  bit_print(&(*fp), objcode[1]);
	  fprintf(*fp, " \n");
}/* end of fmt2 */

/*----------------------  END FORMAT 1 & 2  FUNCTIONS  -----------------------*/
/* submitted by Mother Earth */

