/* FMT3PART.C
/*
/*   SSSS    OOOO   U    U  RRRRR    CCCC   EEEEEE
/*  S       O    O  U    U  R    R  C    C  E
/*  S       O    O  U    U  R    R  C       E
/*   SSSS   O    O  U    U  RRRRR   C       EEE
/*       S  O    O  U    U  R  R    C       R
/*       S  O    O  U    U  R   R   C    C  R
/*   SSSS    OOOO    UUUU   R    R   CCCC   REEEEE
/********************************************************************/
/* ASSIGNMENT: Lab 3 						    */
/* Programmers: Hai Nguyen 		  			    */
/*              Bettina McCormick                                   */
/*              Robert Konczynski, Jr.                              */
/*                                                                  */
/* 			The Three Musketeers			    */
/*                                           	                    */
/*      April 1998, COP 3402 - Systems, Assignment #3               */
/*                                                                  */
/*         Pass 2  - Due Date: April 21, 1998                       */
/*                                                                  */
/* Instructor: Proffesor Enger                                      */
/*                                                                  */
/*------------------------------------------------------------------*/
/*								    */
/********************************************************************
				F M T 3

	FMT3 is an Mnemonic for Format Three.  Format Three is a
	Specific proccess that is acomplished in creating
	Oject code for any instruction that is indicated as Format
	Three.  A Format Three instruction is any Instruction, That
	is to say where any operation has a format 3 or 3 bytes
	for it's instructions.
	This File contains the code that is used to process
	Format 3 instructions.
	All data is passed in through Parameters Utilizing Flexiability
	and Portability.  All Functions within are Original to Format 3.

/*****************************************************************/
/*
/* Function Name: convert_to_hex
/*
/* Purpose: To take in an integer and change it into 6 hex digets
/*          into charcters that store 2 hex digets at one time.
/*          Basically convert a number into 3 bytes of info
/*
/* Pre-Condition : <none> Follow Parameters
/*
/* Post-Condition:
/*         hex_2 : Contains Highest Byte of the 3 byte sequence
/*         hex_1 : Contains The Second Highest Byte of the 3 Byte Sequence
/*         hex_0 : Contains the Lowest Byte (left most) of the 3 byte
/*		   Sequence
/*
/* Return: True or False if it was successful (True anything NOT 0)
/*
/*****************************************************************************/
int convert_to_hex(int number, char *hex_2, char *hex_1, char *hex_0)
{
  int digit;

/*-----------------------------------*/
/* Here I divide out the Higest Byte */
/*-----------------------------------*/
  digit = (int)(number / 256);
  *hex_2 = (char)digit;
  number = number - (digit * 256);

/*-----------------------------------*/
/* Here I divide out the Middle Byte */
/*-----------------------------------*/
  digit = (int)(number / 16);
  *hex_1 = (char)digit;
  number = number - (digit * 16);

/*-----------------------------------*/
/* Here I divide out the Lowest Byte */
/*-----------------------------------*/
  digit = (int)(number / 1);
  *hex_0 = (char)digit;
  number = number - (digit * 1);

  return !number; /*If Anything is Left Over then Return 0 for failure */
};



/*****************************************************************/
/*
/* Function Name: symtab_get
/*
/* Purpose: To find a label in the symbol table passed in and then
/*          pass it's data back through a structure called
/*          Return_record If data is NOT Found return false.
/*
/* Pre-Condition : Symbol_Table is Valid and was initialized
/*                 label_to_find is a Valid label to be hashed
/*
/* Post-Condition:
/*         Return_record : Contains copy of data in symbol table at
/*                 the correct hash.
/*
/*
/* Return: True or False if it was successful (True anything NOT 0)
/*
/*****************************************************************************/
int symtab_get(struct st_entry *Symbol_Table, struct st_entry *Return_record,
	       char label_to_find[])
{
  int hash_index;
  int isfound = 0;

  hash_index = symtab_hash(label_to_find);
  isfound = symtab_search(label_to_find,Symbol_Table,&hash_index);
  if(isfound)
    {
      strcpy(Return_record->st_name, Symbol_Table[hash_index].st_name);
      Return_record->st_type = Symbol_Table[hash_index].st_type;
      Return_record->st_value = Symbol_Table[hash_index].st_value;
    };
  return isfound;
};

/*****************************************************************/
/*
/* Function Name: scan_string_for
/*
/* Purpose: Accepts a string and reports back the index of the found
/*          character.  The charter to look for is indicated by
/*          character.  d If data is NOT Found return false.
/*
/* Pre-Condition : <None>
/*
/* Post-Condition:
/*                Results passed back as an integer
/*
/* Return: Index of string where charter was found or 0
/*
/*****************************************************************************/
int scan_string_for(char character, char string[])
{
  int index = 0;
  int return_value;
  while((string[index] != character) && (string[index] != '\0'))
    {
      index++;
    };
  if(string[index] == character)
    {
      return_value = index;
    }
  else
    {
      /*---------------------------------------------------*/
      /* In this unique case we are allowing a return of 0 */
      /* if the position char found at 0 then you must     */
      /* double check, but in our case it would be obserd  */
      /* to have a , in the first(0) position              */
      /*---------------------------------------------------*/
      return_value = 0;
    };
  return return_value;
};


/*****************************************************************/
/*
/* Function Name: parse_string_for_fmt3
/*
/* Purpose: Accepts a string which is the operand, a character pointer
/*          and two strings left_side, and right_side.  The function
/*          will parse the operand into two fields which is delimited
/*          by a ','.   The function will return the left_side
/*          string, and the right side_string.  If the right side
/*          does not exist then the first char of the right side
/*          will be set to the EOS(End of String) Character '\0'
/*
/*
/* Pre-Condition : operand contains data that can be parsed.
/*
/* Post-Condition:
/*
/*      char *addressing_scheme:
/*                the addressing scheme of '#','@', or 'S' will
/*                be assigned to the character pointer passed in.
/*
/*      char left_side[OPND_LENGTH]:
/*                Reassigned to the
/*		  String on the left side of the operand before
/*                the coma or End of Line.
/*
/*      char right_side[OPND_LENGTH]:
/*		  Reassigned to '\0' or the string on the Right
/*                side of the operand after the coma.
/*		  If coma is NOT present in the string then it
/*                will be assigned to the '\0'.
/*
/*
/*
/* Return: int Number of items parsed 1, or 2
/*
/*****************************************************************************/
int parse_string_for_fmt3(char operand[OPND_LENGTH], char *addressing_scheme,
			  char left_side[NAME_LENGTH], char right_side[NAME_LENGTH])
{
  char *string_ptr;
  char *temp_string;
  char copy_of_operand[OPND_LENGTH];
  char token_coma[] = ",";
  char token_space[] = " \t\n";
  int return_value;

  strcpy(copy_of_operand, operand);
  string_ptr = copy_of_operand;
  switch(string_ptr[0])
    {
      case '@' : *addressing_scheme = '@';
		 string_ptr++;
		 break;

      case '#' : *addressing_scheme = '#';
		 string_ptr++;
		 break;

	default: *addressing_scheme = 'S';
		 break;
    };

  if(scan_string_for(',',string_ptr))
    {
      temp_string = strtok(string_ptr,token_coma);
      strcpy(left_side,temp_string);

      temp_string = strtok(NULL, token_space);
      strcpy(right_side,temp_string);
      return_value = 2;
    }
  else
    {
      temp_string = strtok(string_ptr,token_space);
      strcpy(left_side,temp_string);
      right_side[0] = '\0';
      return_value = 1;
    };
return return_value;
};


/*****************************************************************/
/*
/* Function Name: object_code_generate_displacement
/*
/* Purpose: Generates the displacement of an relocatable address.
/*          The function accepts an array of object code which is
/*          defined as bytes.  It will adjust the last 3 nibbles
/*          also known as half bytes to contain the calculated
/*          displacemnet based on the location counter.  The base
/*          register variable will be used if displacement is
/*          beyond the Program Counter Range.
/*
/* Pre-Condition : object_code array is valid and at least 3 bytes
/*                 long.  Left_value is a valid positive number.
/*
/* Post-Condition:
/*
/*      char object_code will be adjust to hold displacemnet in the
/*                last 3 nibbles.
/*
/*
/* Return: int Type of Addresing Algorithim Used, 'P' for PC
/*             'B' for base, 0 Error.
/*
/*****************************************************************************/
int object_code_generate_displacement(byte object_code[OBJ_LENGTH],
				      int location_counter,
				      int left_value,
				      int base_reg)

{
   int displacement;
   int return_value;
   char byte3;
   char byte2;
   char byte1;

   location_counter += 3;
   displacement = left_value - location_counter;
   if(displacement <= 1023)
     {
	/* PC Addressing */
	/* PC Flag Must Get Flipped */
	convert_to_hex(displacement,&byte1,&byte2,&byte3);
	object_code[2] = (byte2 * 16) + (byte3);
	object_code[1] = object_code[1] + byte1;
	/* Need to enter [1] and preform the following change */
	/* Change bit 11 to a 1 				   */
	/* $$?$$$$$					   */
	/* $$1$$$$$ <-- End Goal				   */
	/* 00100000 <-- Achive by Oring it with this          */
	/* 00 100 000 <-- Octal Patern			   */
	/*  0  4   0  <-- Octal Number			   */
	object_code[1] = object_code[1] | '\040';
	return_value = 'P';
     }
   else
     { /* Try Base */
       /* BASE Addressing */
       displacement = left_value - base_reg;
       if(displacement <= 4096)
	 {
	  /* BASE Worked */
	  convert_to_hex(displacement,&byte1,&byte2,&byte3);
	  object_code[2] = (byte2 * 16) + (byte3);
	  object_code[1] = object_code[1] + byte1;

	      /* Need to enter [1] and preform the following change */
	      /* Change bit 10 to a 1 				   */
	      /* $?$$$$$$					   */
	      /* $1$$$$$$ <-- End Goal				   */
	      /* 01000000 <-- Achive by Oring it with this          */
	      /* 01 000 000 <-- Octal Patern			   */
	      /*  1  0   0  <-- Octal Number			   */
	    object_code[1] = object_code[1] | '\100';
	    return_value = 'B';
	 }
       else
	 {
	   /* FALIURE!  Should have been Format 4 */
	   return_value = 0;
	 }
   };
  return return_value;
};


/********************************************************************/
/* Function Name: fmt3
/*
/* Purpose: To Process Format 3 instructions as indicated by the
/*          SIC / SIC XE Virtual Computer based on the methods
/*          explained in the following cited book:
/*             "SYSTEM SOFTWARE an Introduction to Systems Programming"
/*             Author : Leland L. Beck
/*             Edition: 3rd
/*             Publisher: ADDISON-WESLEY Longman, INC
/*             ISBN : 0-201-42300-6
/*             Dewi Decimal Assignment : QA76.66B42  1997
/*          Format 3 Instructions are instructions that allow
/*          Program Counter, OR Base Relative Addressing.  They
/*          also allow Indirect, Direct and Simple Addressing.
/*          The above mentioned schemes are deterimend in this
/*          format.
/*
/* What Function Does:
/*
/*   Specifications of Format 3 Instruction:
/*   Total Amount of Bytes = 3
/*   Total Bits = 24
/*
/*
/* +-----------------+--+--+--+--+--+--+-----------------------------------+
/* | OP CODE         |n |i |x |b |p |e | RELATIVE DISPLACEMENT or ABSOULTE |
/* +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+-+-+-+-+-+-+-+-+-+--+--+--+
/* |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
/* +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
/*  01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24
/*  bit positions for refrence
/*
/*   Function will accept an Oppeand and a Opcode.  From this
/*   inforamtion Format 3 will construct the proper Object code
/*   for the SIC XE computer.  On entering into the this function
/*   an Index to the Operation Table will be passed in.  This index
/*   is used to retrive the Operand Code for the Object Code.  This
/*   information will be placed in the first byte of the object code.
/*   bits 01 to 08.  After Instruction has been placed into Position
/*   the process continues.
/*   Bit (06, 07, n & i)
/*     Bit position n indicates indirect addressing.  If an Instruction
/*       is to be indirect then the operands first field will contain
/*       the @ symbol. If the @ symbol is not present then
/*       immediate addressing must be checked.  If an Instruction
/*       is to be immediate then the operands first field will contain
/*       the # symbol.  If the @ symbol is encountered then the following
/*       bits must be set: n = 1, and i = 0.  Meaning set bit 07 to 1, and
/*       bit 08 to 0.  Otherwise if the # symbol was encountered then
/*       set n = 0, and i = 1.  Meaning set bit 07 to 0, and bit 08 to 1.
/*       If there is no # or @ then set bits n and i equal to 1.
/*       Meaning set bit 07 to 1, and set bit 08 to 1.  When n = 1, and
/*       i = 1, then this is said to be simple addressing.
/*   Next The opperand is disected and is determined.  The last 3
/*       half bytes also known as nibbles will be adjusted to contain
/*       The displacement from the end of the instruction (+3) to the
/*       data field labeled as a label.  Finaly if Base addressing is
/*       used the b bit is turned on, if pc addressing is used then
/*       the p bit is fliped on.
/*
/* Pre-Condition:
/*       FILE **Output : Already open in WRITE mode
/*       byte object_code[OBJ_LENGTH] : Contains at least 3 bytes
/*       ot_entry operation_table[] : Initialized and filled
/*       char operand[OPND_LENGTH] : Operand data
/*       int operation_index : Index into Operation Table of Operation
/*       st_entry *Symbol_Table : Initialized and filled.
/*       int location_counter : Current location Counter
/*       int lineno : Current Line Number
/*       int base_reg : Base Register value, a Positive Number or 0.
/*
/* Post-Condition:
/*       Output : Object Code Written to it, and End of Line written
/*       object_code : Adjusted for current object code
/*
/* Return void
/*
/**********************************************************************/
void fmt3(FILE **Output,
	  byte object_code[OBJ_LENGTH],
	  struct ot_entry operation_table[],
	  char operand[OPND_LENGTH],
	  int  operation_index,
	  struct st_entry *Symbol_Table,
	  int location_counter,
	  int lineno,
	  int base_reg)
/* This routine is used by pass2 to process format 3. */
{
   char addressing_scheme;
   char left_side[NAME_LENGTH];
   char right_side[NAME_LENGTH];
   int number_of_labels;
   int left_value;
   int right_value;
   struct st_entry symbol_entry;
   int left_type;
   char byte3;
   char byte2;
   char byte1;

   left_type = 0;

   object_code[0] = operation_table[operation_index].ot_opcode;
   object_code[1] = 0;
   object_code[2] = 0;
   number_of_labels = parse_string_for_fmt3(operand, &addressing_scheme,
					    left_side, right_side);
   /* LABELS MUST begin with letters.  If it is not a letter and it's a */
   /* number then we can assume the string is a number 			*/
   if((left_side[0] >= '0') && (left_side[0] <= '9'))
     {
       left_value = atoi(left_side);
       left_type = 'A';
     }
   else if(symtab_get(Symbol_Table, &symbol_entry, left_side))
     {
	left_value = symbol_entry.st_value;
	left_type = symbol_entry.st_type;

	if(symtab_get(Symbol_Table, &symbol_entry, right_side) && (number_of_labels == 2))
	  {
	    right_value = symbol_entry.st_value;
	    /* Change first Bit { 1$$$$$$$ }*/
	    object_code[1] = object_code[1] | '\200';
	  };
     }
   else
     {
       fprintf(*Output,"<< Unidentified Label in the Symbol Tabel, Data not Found >> \n");
     }
   /* The Object Code = XX XX XX  ||||||nixbpe||||||||||||  */
   /* Adjust n & i    = ^        */
   switch(addressing_scheme)
     {
       case '@': /* 10 ni */
		 /* $$$$$$10 Our Goal */
		 /* 11111110 ANDING   */
		 /* 00000010 OR ing   */
		 object_code[0] = (byte)object_code[0] & '\376';
		 object_code[0] = (byte)object_code[0] | '\002';
		 object_code_generate_displacement(object_code,
						   location_counter,
						   left_value,
						   base_reg);

		 /* All other Bits are fine, they stay at thier default values */
		 break;

       case '#': /* 01 ni */
		 /* $$$$$$01 Our Goal */
		 /* 11111101 ANDING   */
		 /* 00000001 OR ing   */
		 object_code[0] = (byte)(object_code[0] & '\375');
		 object_code[0] = (byte)(object_code[0] | '\001');
		 if(left_type == 'A')
		   {
		     convert_to_hex(left_value,&byte1,&byte2,&byte3);
		     object_code[2] = (byte2 * 16) + (byte3);
		     object_code[1] = object_code[1] + byte1;
		   }
		 else
		   {
		      object_code_generate_displacement(object_code,
							location_counter,
							left_value,
							base_reg);
		   };

		 break;

       case 'S': /* 11 ni */
		 /* $$$$$$11 Our Goal */
		 /* 00000011 OR ing   */
		 object_code[0] = (byte)(object_code[0] | '\003');
		 object_code_generate_displacement(object_code,
						   location_counter,
						   left_value,
						   base_reg);

		 break;

       }; /* end switch */
     if(number_of_labels > 1)
       {
	 /* Indexing was used flip the X bit                  */
	 /* Lives in Position 1                               */
	 /* xbpe                                              */
	 /* 1$$$$$$$ <-- Goal                                 */
	 /* 10000000 <-- Achive by Oring it with this Pattern */
	 /* 10 000 000  <-- Octal Break down                  */
	 /* 2  0    0   <-- Octal Code 			      */
	 object_code[1] = object_code[1] | '\200';
       };

  fprintf(*Output, "%3d   %3.2X%3.2X%3.2X%3.2c     ",
		  lineno, objcode[0], objcode[1], objcode[2], BLANK);

	  bit_print(&(*Output), objcode[0]);
	  fprintf(*Output, " ");
	  bit_print(&(*Output), objcode[1]);
	  fprintf(*Output, " ");
	  bit_print(&(*Output), objcode[2]);
	  fprintf(*Output, " ");

	  fprintf(*Output, " \n");


    if (right_value == 0 + 0)
     {};

   }/* end of fmt3 */
