/* OPTBPART.C
/*
/*   SSSS    OOOO   U    U  RRRRR    CCCC   EEEEEE
/*  S       O    O  U    U  R    R  C    C  E
/*  S       O    O  U    U  R    R  C       E
/*   SSSS   O    O  U    U  RRRRR   C       EEE
/*       S  O    O  U    U  R  R    C       R
/*       S  O    O  U    U  R   R   C    C  R
/*   SSSS    OOOO    UUUU   R    R   CCCC   REEEEE
/*****************************************************************************\
			   Fire, Earth, and Wind
	   (a.k.a. Hai Nguyen, Bettina McCormick  & Rob Konczynski, Jr.)

	      April 1998, COP 3402 - Systems, Assignment #3

		   Pass 2  - Due Date: April 27, 1998

 *--------------------    OPERATION TABLE  FUNCTIONS  ------------------------*

\******************************************************************************/						

/*------------------------- O P T A B _ I N I T  ------------------------------\

 Purpose: Initializes the operation table

 Pre-Condition : <None>

 Post-Condition:  Operation table passed is initialized

 Return: void

\-----------------------------------------------------------------------------*/
void optab_init(struct ot_entry *ot)
{
	int i;

	for (i=0; i< OT_SIZE; i++)
	{
		ot[i].ot_mnemonic[0]='\0';
		ot[i].ot_format = NADA;
		ot[i].ot_temp[0] = 0;
		ot[i].ot_opcode = 0;
	}
} /* end 	optab_init */

/*--------------------------  O P T A B _ L O A D  ----------------------------\

 Purpose: Takes the pointer to the optab input file and loads the optab

 Pre-Condition : <none> Follow Parameters

 Post-Condition:  input file has been inserted to optab

 Return: void

\-----------------------------------------------------------------------------*/
void optab_load(FILE **fp, struct ot_entry *ot, int *ot_cnt)
{
	while (fscanf(*fp, "%s", ot[ot_count].ot_mnemonic)!=EOF)
	{
		fscanf(ot_fptr, "%d", &ot[ot_count].ot_format);
		fscanf(ot_fptr, "%X", &ot[ot_count].ot_opcode);
		*ot_cnt = *ot_cnt + 1;
	}
} /* end optab_load */


/*------------------------ O P T A B _ W R I T E ----------------------------\

 Purpose: Writes the optab contents to a file

 Pre-Condition : <none> Follow Parameters

 Post-Condition: optab is written to file

 Return: void

\-----------------------------------------------------------------------------*/
void optab_write(FILE **fp, struct ot_entry *ot, int ot_cnt)
{
	int j;

	fprintf(*fp, "   The Operation Table\n");
	fprintf(*fp, "Index   Operation   Format   Opcode\n");
	for (j = 0; j < ot_cnt; j++)
	{
		fprintf(*fp,"%3d     %-8s    %3d       %3.2X\n",
		j, ot[j].ot_mnemonic, ot[j].ot_format, ot[j].ot_opcode);
	}  /* end for */
} /* end write_optab */

/*-------------------- END OPERATION TABLE FUNCTIONS  ----------------------*/
/* submitted by Mother Earth */

