/* FMT0PART.C
/*
/*   SSSS    OOOO   U    U  RRRRR    CCCC   EEEEEE
/*  S       O    O  U    U  R    R  C    C  E
/*  S       O    O  U    U  R    R  C       E
/*   SSSS   O    O  U    U  RRRRR   C       EEE
/*       S  O    O  U    U  R  R    C       R
/*       S  O    O  U    U  R   R   C    C  R
/*   SSSS    OOOO    UUUU   R    R   CCCC   REEEEE
/*****************************************************************************\
			   Fire, Earth, and Wind
	   (a.k.a. Hai Nguyen, Bettina McCormick  & Rob Konczynski, Jr.)

	      April 1998, COP 3402 - Systems, Assignment #3

		   Pass 2  - Due Date: April 27, 1998

 *-------------------------- FORMAT 0 FUNCTION  ------------------------------*

\******************************************************************************/	
/*-------------------------------- F M T 0  -----------------------------------\

 Purpose: This routine is used by pass2 to process format 0 instructions.

 Pre-Condition : <None>

 Post-Condition:

 Return: void

\-----------------------------------------------------------------------------*/
void fmt0 (FILE **fp, char lbl[NAME_LENGTH + 1], char opr[OP_LENGTH + 1],
				 char ond[OPND_LENGTH + 1], struct st_entry *st)
/* This routine is used by pass2 to process format 0 (assembler */
/* directives).                                                 */
{
	char  temp[8],
	      half_byteL,    /*stores hex digits*/
              half_byteR,
	      single_byte,
	      word_array[7];
	/*Used to store numbers which have been converted from HEX example: if
	  you had label WORD 4096---word_array stores 1000 each digit being a
	  char to be compacted for entry into objcode*/

	int   i=0, j=0, k=0, l=0,
		byte_num=0,
		num_of_spaces,    /*tells you how many spaces to move over */
		temp_int;

	/*initializing all your strings */
	objcode[0]='\0';
	word_array[0]='\0';
	temp[0]='\0';

	fprintf(*fp, "%3d    ", lineno);
	if (strcmp(opr, "BYTE")==0)
	{
		if (ond[0]=='C')
		{
			i=2; j=0;
			while (ond[i]!='\0' && ond[i]!='\'')
			{
				objcode[j]=ond[i];
				j++;
				i++;
			}
			objcode[j]='\0';
			i=0;
			while (objcode[i]!='\0')
			{
				byte_to_hex(&temp_fptr, objcode[i]);
			 /*Prints out each byte of objcode as two hex digits*/
				i++;
			}/* Lines up cursor for printing out objcode in bin*/
			num_of_spaces= spaces[i];   
			for (i=1; i<=num_of_spaces; i++)
				fprintf(*fp, " ");
			i=0;
			while (objcode[i]!='\0')
			{
				bit_print(&temp_fptr, objcode[i]);
				fprintf(*fp, " ");
				i++;
			}
		} /*end 'C' */

		if (ond[0]=='X')
		{
			i=0; j=2;
			while (ond[j]!='\'') 
				/*Ex. in operand X'BLAH' this cuts out everything*/
			{                  /*excepth BLAH and stores it in temp*/
				temp[i]=ond[j];
				i++;
				j++;
			}
			temp[i]='\0';

		/* this code fragment will go through and process two chars at
		   a time and take each pair of chars and convert them into hex by
		    compressing each pair of chars---bytes into one single byte*/
			byte_num = strlen(temp)/2;
			k=0; l=0;
			for (i=1; i<=byte_num; i++)
			{
				half_byteL= temp[k];
				k++;
				half_byteR= temp[k];
				k++;
				two_hex_to_byte(half_byteL, half_byteR, &single_byte);
				objcode[l]= single_byte;
				l++;
			}
			if (l <= 4)
				objcode[l]='\0';
			i=0;
			while (objcode[i]!='\0')
			{
				byte_to_hex(&temp_fptr, objcode[i]);
			/*Prints out each byte of objcode as two hex digits*/
				i++;
			}
			num_of_spaces= spaces[byte_num]; 
				/* Lines up cursor for printing out objcode */
			for (i=1; i<=num_of_spaces; i++) /* in bin*/
				fprintf(*fp, " ");
			i=0;
			while (objcode[i]!='\0')
			{
				bit_print(&temp_fptr, objcode[i]);
				fprintf(*fp, " ");
				i++;
			}
		} /* end X */
	} /* end BYTE */
	if (strcmp(opr, "WORD")==0)
	{
		sscanf(ond, "%d", &temp_int);
		decimal_to_hex(temp_int, word_array);
				 /* returns word_array as a string with the HEX*/
		k=0; l=0;   /*representation of temp_int, each hex digit as*/
		for (i=0; i<3; i++) /*an individual char */
		{
			half_byteL= word_array[k];
			k++;
			half_byteR= word_array[k];
			k++;
			two_hex_to_byte(half_byteL, half_byteR, &single_byte);
			objcode[l]= single_byte;
			l++;
		}
		for (i=0; i<=2; i++)
		byte_to_hex(&temp_fptr, objcode[i]);
	  /*Prints out each byte of objcode as two hex digits*/

		num_of_spaces= spaces[3]; 
			/* Lines up cursor for printing out objcode */
		for (i=1; i<=num_of_spaces; i++) /* in bin*/
			fprintf(*fp, " ");
		for (i=0; i<3; i++)
		{
			bit_print(&temp_fptr, objcode[i]);
			fprintf(*fp, " ");
		}
	} /* end WORD */


	/*directive which sets up teh value to be used for base relative
	addressing */
	if (strcmp(opr, "BASE")==0)
	{
		i=0;
		while (strcmp(st[i].st_name, ond)!=0)
			i++;
		basereg= st[i].st_value;
	}
	if (strcmp(opr, "NOBASE")==0)
	{
		basereg=0;
	}
	fprintf(*fp, "\n");
} /* End fmt0() */