;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		Bettina McCormick	 		LAB 2 - Due June 29, 1998	
;
;           COP 4020 SUM '98			More LISP Functions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Lab2: part ONE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;___________________Make____________________      
;This function accepts two lists L1a and L2a.  
;The function returns the Cartesian product of the first element in L1a 
;and each element in L2a.
;
(defun Make (L1a L2a) 
	     (mapcar (defun lambda (X2)
                  (list (car L1a) X2)
             ) L2a )
)

;________________CartProd__________________      
;This function accepts two lists L1 and L2.  
;The function returns the Cartesian product of L1 and L2.
;
(defun CartProd (L1 L2)
          (cond
   		( (null L1) NIL )
		( (null L2) NIL )
		((null (cdr L1)) (Make L1 L2))
		(T (cons (Make L1 L2) (CartProd (cdr L1) L2) ) ) 
	  )  
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Lab2: part TWO ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;__________________FibNo________________
;The function returns the Xth number in the fibonacci sequence.
(defun FibNo (X)
		(cond
		((equal X 1) 0)
		((equal X 2) 1)
		(T (+ (FibNo (- X 1)) (FibNo (- X 2)))) 
		)
)

;__________________SeqList________________
;The function returns a list of numbers in consecutive order from N to M.
(defun SeqList (N M)
		(cond
			((equal M 0) 0)
			((equal N M) M)
			(T (cons N (SeqList (+ N 1) M))) 
		)
)

;__________________RangeFib________________
;This function accepts two integers N and M.  
;The function returns a list containing the Nth through Mth Fibonacci numbers
;(i.e., M-N+1 Fibonacci numbers).
;
(defun RangeFib (N M)
          (cond
		((equal M 0) NIL)
		(T (mapcar (function FibNo)) (SeqList N M))) 
	  ) 
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;; Lab2: part THREE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;__________________RemoveTopLevel______________
;This function accepts an atom R1 and a list L1.  
;The function returns a list equivalent to L1 with all occurrences of R1 removed. 
;
(defun RemoveTopLevel (R1 L1) 
     (cond
          ( (null L1) NIL)
          ((member R1 L1) (remove R1 L1))
 	  (T (L1))		    
     )
)

;_________________OnlyAtoms________________
;This function accepts a list L1.  
;The function returns T if the list L1 contains only atoms. 
;The function ret#rns nil otherwise.
;
(defun OnlyAtoms (L1) 
     (cond
          ((null L1) T)
	  ((atom (car L1) ) (OnlyAtoms (cdr L1)))
 	  (T nil)
     )
)

;____________________RemoveAll______________________
;This function accepts an atom RemAtom and a list L.  
;The function returns a list equivalent to L with all 
;occurrences of RemAtom removed. 
;
(defun RemoveAll (RemAtom L)  
 (cond
   ((null L) NIL)
   ((equal (car L) RemAtom) (RemoveAll RemAtom (RemoveTopLevel RemAtom L))) 
   ((null (atom (car L))) (cond 
			((OnlyAtoms (car L)) (removeTopLevel RemAtom (car L)))
			(T (RemoveAll RemAtom (car L)))
			))
   (T (list (car L) (RemoveAll RemAtom (cdr L))))
 )
)
